VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWebRadio"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' ---=== Const ===---
Private Const S_OK As Long = &H0&
Private Const API_TRUE As Long = &H1&
Private Const API_FALSE As Long = &H0&
Private Const INTERNET_SERVICE_HTTP As Long = &H3&
Private Const INTERNET_DEFAULT_HTTP_PORT As Long = 80&
Private Const INTERNET_DEFAULT_HTTPS_PORT As Long = 443&
Private Const INTERNET_OPEN_TYPE_PRECONFIG As Long = &H0&
Private Const INTERNET_OPEN_TYPE_DIRECT As Long = &H1&
Private Const INTERNET_FLAG_SECURE As Long = &H800000
Private Const INTERNET_FLAG_RELOAD As Long = &H80000000
Private Const HTTP_QUERY_FLAG_REQUEST_HEADERS As Long = &H80000000
Private Const HTTP_QUERY_STATUS_CODE As Long = 19&
Private Const HTTP_QUERY_RAW_HEADERS_CRLF As Long = 22&
Private Const SXH_OPTION_IGNORE_SERVER_SSL_CERT_ERROR_FLAGS As Long = 2&
Private Const SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS As Long = 13056&

Private Const WEB_AGENT As String = "WinampMPEG/5.09"
Private Const WEB_HEADER As String = "Icy-MetaData:1" '<- mit icy-metaint,  "Icy-MetaData:0" <- ohne icy-metaint
Private Const WEB_VERSION As String = "HTTP/1.1"

Private Const sQueryData As String = "icy-name,ice-audio-info,icy-audio-info,icy-description," & _
                                     "icy-br,icy-sr,icy-genre,icy-url,icy-pub," & _
                                     "icy-metaint,Content-Type,Server,Date,Expires"

' ---=== Enum ===---
Public Enum QueryData
     IcyName = 0&
     IceAudioInfo = 1&
     IcyAudioInfo = 2&
     IcyDescription = 3&
     IcyBitrate = 4&
     IcySampleRate = 5&
     IcyGenre = 6&
     IcyUrl = 7&
     IcyPublic = 8&
     IcyMetaInt = 9&
     ContentType = 10&
     Server = 11&
     Date = 12&
     Expires = 13&
End Enum

' ---=== wininet.dll ===---
Private Declare Function InternetOpen Lib "wininet.dll" _
                         Alias "InternetOpenW" ( _
                         ByVal sAgent As Long, _
                         ByVal lAccessType As Long, _
                         ByVal sProxyName As Long, _
                         ByVal sProxyBypass As Long, _
                         ByVal lFlags As Long) As Long

Private Declare Function InternetConnect Lib "wininet.dll" _
                         Alias "InternetConnectW" ( _
                         ByVal hInternetSession As Long, _
                         ByVal sServerName As Long, _
                         ByVal nServerPort As Long, _
                         ByVal sUsername As Long, _
                         ByVal sPassword As Long, _
                         ByVal lService As Long, _
                         ByVal lFlags As Long, _
                         ByVal lContext As Long) As Long

Private Declare Function HttpOpenRequest Lib "wininet.dll" _
                         Alias "HttpOpenRequestW" ( _
                         ByVal hHttpSession As Long, _
                         ByVal sVerb As Long, _
                         ByVal sObjectName As Long, _
                         ByVal sVersion As Long, _
                         ByVal sReferer As Long, _
                         ByVal something As Long, _
                         ByVal lFlags As Long, _
                         ByVal lContext As Long) As Long

Private Declare Function HttpSendRequest Lib "wininet.dll" _
                         Alias "HttpSendRequestW" ( _
                         ByVal hHttpRequest As Long, _
                         ByVal sHeaders As Long, _
                         ByVal lHeadersLength As Long, _
                         ByVal sOptional As Long, _
                         ByVal lOptionalLength As Long) As Long

Private Declare Function HttpQueryInfo Lib "wininet.dll" _
                         Alias "HttpQueryInfoW" ( _
                         ByVal hHttpRequest As Long, _
                         ByVal lInfoLevel As Long, _
                         ByVal sBuffer As Long, _
                         ByVal lBufferLength As Long, _
                         ByVal lIndex As Long) As Long

Private Declare Function InternetCloseHandle Lib "wininet.dll" ( _
                         ByVal hInet As Long) As Long

Private Declare Function InternetOpenUrl Lib "wininet.dll" _
                         Alias "InternetOpenUrlW" ( _
                         ByVal hInternetSession As Long, _
                         ByVal lpszUrl As Long, _
                         ByVal lpszHeaders As Long, _
                         ByVal dwHeadersLength As Long, _
                         ByVal dwFlags As Long, _
                         ByVal dwContext As Long) As Long

Private Declare Function InternetReadFile Lib "wininet.dll" ( _
                         ByVal hFile As Long, _
                         ByVal lpBuffer As Long, _
                         ByVal dwNumberOfBytesToRead As Long, _
                         ByRef lpdwNumberOfBytesRead As Long) As Integer

' ---=== Events ===---
Public Event QueryStream(ByVal bQueryOk As Boolean)

Public Event RecStreamCurrentPlaying(ByVal sStreamTitle As String, _
    ByVal sStreamUrl As String, ByVal sStreamMetaDataRaw As String)

' ---=== Variablen ===---
Private m_StopRec As Boolean
Private m_strStreamUrl As String
Private m_arrQueryData() As String
Private m_arrQueryInfo() As String
Private m_arrPlaylistInfo() As String

Private Sub Class_Initialize()

    m_StopRec = False
    m_strStreamUrl = vbNullString
    m_arrQueryData = Split(sQueryData, ",")
    
End Sub

Private Sub Class_Terminate()

    m_StopRec = True
    
End Sub

Public Property Let StreamUrl(ByVal sUrl As String)
    
    If Len(sUrl) > 0& Then
    
        m_strStreamUrl = Trim$(sUrl)
        
        Call QueryStreamUrl
        
    End If

End Property

Public Property Get StreamUrl() As String
    
    StreamUrl = m_strStreamUrl

End Property

Public Function IsUrlPlaylist(ByVal sUrl As String) As Boolean
    
    Dim bolRet As Boolean
    Dim strTmp As String
    Dim strRet As String
    Dim lngItem As Long
    Dim lngArrItem As Long
    Dim lngCount As Long
    Dim arrEXTM3U() As String
    Dim objXMLHTTP As Object
    Dim datTimeToWait As Date
    
    bolRet = False
    sUrl = Trim$(sUrl)
    
    If Len(sUrl) > 0& Then
    
        Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP.6.0")
        
        objXMLHTTP.SetOption SXH_OPTION_IGNORE_SERVER_SSL_CERT_ERROR_FLAGS, _
            SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS
        
        objXMLHTTP.Open "GET", sUrl, True
        objXMLHTTP.Send
    
        datTimeToWait = DateAdd("s", 1, Now)
    
        Do While objXMLHTTP.ReadyState <> 4
            DoEvents
            If Now >= datTimeToWait Then Exit Do
        Loop
    
        If objXMLHTTP.ReadyState = 4 Then
        
            strRet = Trim$(objXMLHTTP.responseText)
            
            'Debug.Print strRet
            
            If Left$(LCase$(strRet), Len("[playlist]")) = "[playlist]" Then
            
                bolRet = True
                m_arrPlaylistInfo = Split(strRet, vbCrLf)
            
            ElseIf Left$(LCase$(strRet), Len("http://")) = "http://" Then
            
                strTmp = "[playlist]" & vbCrLf
                strTmp = strTmp & "NumberOfEntries = 1" & vbCrLf
                strTmp = strTmp & "File1=" & strRet & vbCrLf
                strTmp = strTmp & "Title1=unknown" & vbCrLf
                strTmp = strTmp & "Length1 = -1" & vbCrLf
                strTmp = strTmp & "Version = 2"
            
                bolRet = True
                m_arrPlaylistInfo = Split(strTmp, vbCrLf)
                
                
            ElseIf Left$(LCase$(strRet), Len("https://")) = "https://" Then
            
                strTmp = "[playlist]" & vbCrLf
                strTmp = strTmp & "NumberOfEntries = 1" & vbCrLf
                strTmp = strTmp & "File1=" & strRet & vbCrLf
                strTmp = strTmp & "Title1=unknown" & vbCrLf
                strTmp = strTmp & "Length1 = -1" & vbCrLf
                strTmp = strTmp & "Version = 2"
            
                bolRet = True
                m_arrPlaylistInfo = Split(strTmp, vbCrLf)
                
            ElseIf Left$(LCase$(strRet), Len("#extm3u")) = "#extm3u" Then
            
                arrEXTM3U = Split(strRet, vbCrLf)
                
                lngCount = UBound(arrEXTM3U) / 2
                
                If lngCount >= 0& Then
                
                    lngArrItem = 1
                    strTmp = "[playlist]" & vbCrLf
                    strTmp = strTmp & "NumberOfEntries = " & CStr(lngCount) & vbCrLf
                    
                    For lngItem = 0 To lngCount - 1
                        
                        strTmp = strTmp & "File" & CStr(lngItem + 1) & "=" & Trim$(arrEXTM3U(lngArrItem + 1)) & vbCrLf
                        strTmp = strTmp & "Title" & CStr(lngItem + 1) & "=" & Trim$(Mid$(arrEXTM3U(lngArrItem + 0), _
                            InStr(1, arrEXTM3U(lngArrItem + 0), ",") + 1)) & vbCrLf
                        strTmp = strTmp & "Length" & CStr(lngItem + 1) & " = -1" & vbCrLf
                        
                        lngArrItem = lngArrItem + 2
                        
                    Next lngItem
                    
                    strTmp = strTmp & "Version = 2"
                
                    bolRet = True
                    m_arrPlaylistInfo = Split(strTmp, vbCrLf)
                
                End If
            
            End If
            
        End If
    
        objXMLHTTP.abort
    
        Set objXMLHTTP = Nothing
    
    End If
    
    IsUrlPlaylist = bolRet
    
End Function

Public Sub GetPlaylistEntry(ByVal lEntryIndex As Long, ByRef sStreamUrl As String, ByRef sStreamTitle As String)

    Dim lEntry As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim arrInfo() As String

    lEntry = lEntryIndex + 1
    sStreamUrl = vbNullString
    sStreamTitle = vbNullString

    If lEntry >= 1& Then
    
        If lEntry <= GetPlaylistNumberOfEntries Then
    
            lngCount = UBound(m_arrPlaylistInfo)
    
            If lngCount >= 0& Then
    
                For lngItem = 0 To lngCount
        
                    arrInfo = Split(m_arrPlaylistInfo(lngItem), "=")
            
                    If UBound(arrInfo) > 0& Then
                    
                        If LCase$(Trim$(arrInfo(0))) = LCase$("File" & CStr(lEntry)) Then
                            
                            sStreamUrl = Trim$(arrInfo(1))
                            
                        ElseIf LCase$(Trim$(arrInfo(0))) = LCase$("Title" & CStr(lEntry)) Then
                            
                            sStreamTitle = Trim$(arrInfo(1))
                            
                        End If
                
                    End If
            
                Next lngItem
        
            End If
        
        End If
    
    End If

End Sub

Public Function GetPlaylistNumberOfEntries() As Long

    Dim lngRet As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim arrInfo() As String
    
    lngRet = 0&
    lngCount = UBound(m_arrPlaylistInfo)
    
    If lngCount >= 0& Then
    
        For lngItem = 0 To lngCount
        
            arrInfo = Split(m_arrPlaylistInfo(lngItem), "=")
            
            If UBound(arrInfo) > 0& Then
            
                If LCase$(Trim$(arrInfo(0))) = LCase$("NumberOfEntries") Then
                
                    lngRet = CLng(Trim$(arrInfo(1)))
                
                    Exit For
                
                End If
            
            End If
        
        Next lngItem
    
    End If

    GetPlaylistNumberOfEntries = lngRet

End Function

Public Function GetPlaylistInfoRawCrLf() As String

    If UBound(m_arrPlaylistInfo) >= 0& Then

        GetPlaylistInfoRawCrLf = Join(m_arrPlaylistInfo, vbCrLf)
        
    End If

End Function

Public Function GetStreamQueryInfoRawCrLf() As String
    
    If UBound(m_arrQueryInfo) >= 0& Then
    
        GetStreamQueryInfoRawCrLf = Join(m_arrQueryInfo, vbCrLf)
    
    End If

End Function

Public Function GetStreamQueryInfo(ByVal eQueryData As QueryData) As String

    Dim strRet As String
    Dim strInfo As String
    Dim lngItem As Long
    Dim lngCount As Long
    Dim arrInfo() As String

    strInfo = m_arrQueryData(eQueryData)
    lngCount = UBound(m_arrQueryInfo)

    If lngCount >= 0& Then

        For lngItem = 0 To lngCount

            arrInfo = Split(m_arrQueryInfo(lngItem), ":")

            If UBound(arrInfo) >= 0& Then

                If LCase$(arrInfo(0)) = LCase$(strInfo) Then

                    If LCase$(strInfo) = "icy-url" Then

                        strRet = strRet & Trim$(arrInfo(1)) & ":" & _
                            Trim$(arrInfo(2)) & ","

                    Else

                        strRet = strRet & Trim$(arrInfo(1)) & ","

                    End If

                End If

            End If

        Next lngItem

    End If

    If Right$(strRet, 1) = "," Then

        strRet = Mid$(strRet, 1, Len(strRet) - 1)

    End If

    GetStreamQueryInfo = strRet

End Function

Public Sub StartRecStream(ByVal sContentType As String, Optional ByVal sMetaInt As String = vbNullString)
    
    m_StopRec = False
    
    If sMetaInt <> vbNullString Then
    
        Call RecStreamWithMeta(sContentType, CLng(sMetaInt))
        
    Else
    
        Call RecStreamWithOutMeta(sContentType)
    
    End If
    
End Sub

Public Sub StopRecStream()
    
    m_StopRec = True
    
End Sub

Private Sub RecStreamWithOutMeta(ByVal sContentType As String)

    Dim lngFNr As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim lngFlag As Long
    Dim lngMetaInt As Long
    Dim lngMetaLen As Long
    Dim lngRetSize As Long
    Dim lngBuffSize As Long
    Dim lngMetaItem As Long
    Dim lngMetaCount As Long
    Dim bolInfo As Boolean
    Dim bolFile As Boolean
    Dim bytBuffer() As Byte
    Dim strFileExt As String
    Dim strMetaData As String
    Dim arrMetaData() As String
    Dim arrMetaInfo() As String
    Dim strStreamTitle As String
    Dim strStreamUrl As String
    Dim hFile As Long
    Dim hInternet As Long

    bolFile = False

    If Len(m_strStreamUrl) > 0& Then

        lngBuffSize = 512
        ReDim bytBuffer(lngBuffSize - 1)
        
        Select Case LCase$(sContentType)
        
        Case Is = "audio/mpeg"
           strFileExt = ".mp3"
                
        Case Is = "audio/aac"
           strFileExt = ".m4a"
           
        Case Is = "audio/aacp"
           strFileExt = ".m4a"
    
        Case Is = "audio/mp4"
           strFileExt = ".m4a"
    
        Case Is = "audio/ogg"
           strFileExt = ".ogg"
           
        Case Is = "application/ogg"
           strFileExt = ".ogg"
        
        End Select

        If Left$(LCase$(m_strStreamUrl), Len("http://")) = "http://" Then
            lngFlag = INTERNET_FLAG_RELOAD
            
        ElseIf Left$(LCase$(m_strStreamUrl), Len("https://")) = "https://" Then
            lngFlag = INTERNET_FLAG_RELOAD Or INTERNET_FLAG_SECURE
            
        End If

        hInternet = InternetOpen(StrPtr(WEB_AGENT), INTERNET_OPEN_TYPE_PRECONFIG _
            Or INTERNET_OPEN_TYPE_DIRECT, 0&, 0&, 0&)

        If hInternet <> 0& Then
        
            hFile = InternetOpenUrl(hInternet, StrPtr(m_strStreamUrl), _
                0&, 0&, lngFlag, 0&)

            If hFile <> 0& Then
                
                lngFNr = FreeFile
                
                Open App.Path & "\record" & strFileExt For Binary As #lngFNr
            
                Do
                    
                    If InternetReadFile(hFile, VarPtr(bytBuffer(0)), _
                        lngBuffSize, lngRetSize) = API_TRUE Then
                    
                        If lngRetSize <> 0& Then
                        
                            Put #lngFNr, , bytBuffer
                            
                        End If
                    
                    End If
                    
                    DoEvents
            
                Loop Until m_StopRec = True
                
                Close #lngFNr
            
                Call InternetCloseHandle(hFile)
            
            End If
        
            Call InternetCloseHandle(hInternet)

        End If
    
    End If

End Sub

Private Sub RecStreamWithMeta(ByVal sContentType As String, ByVal lMetaInt As Long)

    Dim lngFNr As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim lngFlag As Long
    Dim lngMetaInt As Long
    Dim lngMetaLen As Long
    Dim lngRetSize As Long
    Dim lngBuffSize As Long
    Dim lngMetaItem As Long
    Dim lngMetaCount As Long
    Dim lngMetaExCount As Long
    Dim bolInfo As Boolean
    Dim bolFile As Boolean
    Dim bytBuffer() As Byte
    Dim strFileExt As String
    Dim strMetaData As String
    Dim arrMetaData() As String
    Dim arrMetaInfo() As String
    Dim strStreamTitle As String
    Dim strStreamUrl As String
    Dim hFile As Long
    Dim hInternet As Long

    lngMetaInt = lMetaInt

    bolFile = False

    If Len(m_strStreamUrl) > 0& Then

        lngBuffSize = 512
        ReDim bytBuffer(lngBuffSize - 1)

        Select Case LCase$(sContentType)
        
        Case Is = "audio/mpeg"
           strFileExt = ".mp3"
        
        Case Is = "audio/aac"
           strFileExt = ".m4a"
                
        Case Is = "audio/aacp"
           strFileExt = ".m4a"
                
        Case Is = "audio/mp4"
           strFileExt = ".m4a"
                
        Case Is = "audio/ogg"
           strFileExt = ".ogg"
                
        Case Is = "application/ogg"
           strFileExt = ".ogg"
                
        End Select

        If Left$(LCase$(m_strStreamUrl), Len("http://")) = "http://" Then
            lngFlag = INTERNET_FLAG_RELOAD
            
        ElseIf Left$(LCase$(m_strStreamUrl), Len("https://")) = "https://" Then
            lngFlag = INTERNET_FLAG_RELOAD Or INTERNET_FLAG_SECURE
            
        End If

        hInternet = InternetOpen(StrPtr(WEB_AGENT), INTERNET_OPEN_TYPE_PRECONFIG _
            Or INTERNET_OPEN_TYPE_DIRECT, 0&, 0&, 0&)

        If hInternet <> 0& Then
        
            hFile = InternetOpenUrl(hInternet, StrPtr(m_strStreamUrl), _
                StrPtr(WEB_HEADER), -1&, lngFlag, 0&)

            If hFile <> 0& Then
            
                Do
                
                    If InternetReadFile(hFile, VarPtr(bytBuffer(0)), _
                        lngBuffSize, lngRetSize) = API_TRUE Then
                    
                        If lngRetSize <> 0& Then
                        
                            For lngItem = 0 To lngRetSize - 1
                            
                                If lngMetaLen <> 0& Then
                                
                                    bolInfo = False
                                    lngMetaLen = lngMetaLen - 1
                                    strMetaData = strMetaData & ChrW$(bytBuffer(lngItem))
                                    
                                    If lngMetaLen = 0& Then
                                    
                                        If Len(strMetaData) > 0& Then
                                            
                                            bolInfo = True
                                        
                                            strMetaData = Replace$(strMetaData, vbLf, vbNullString)
                                            
                                            arrMetaData = Split(strMetaData, ";")
                                        
                                            lngMetaCount = UBound(arrMetaData)
                                        
                                            If lngMetaCount >= 0& Then
                                            
                                                For lngMetaItem = 0 To lngMetaCount
                                                
                                                    If InStr(1, arrMetaData(lngMetaItem), "StreamTitle", vbTextCompare) > 0& Then
                                                    
                                                        arrMetaInfo = Split(arrMetaData(lngMetaItem), "=")
                                                        arrMetaInfo(1) = Replace$(arrMetaInfo(1), "'", vbNullString)
                                                        
                                                        If Len(arrMetaInfo(1)) > 0& Then
                                                            
                                                            strStreamTitle = arrMetaInfo(1)
                                                            
                                                            strStreamTitle = Replace$(strStreamTitle, ":", "_")
                                                            
                                                            If lngFNr <> 0 Then Close #lngFNr
                                                            
                                                            lngFNr = FreeFile
                                                            
                                                            Open App.Path & "\" & strStreamTitle & strFileExt For Binary As #lngFNr
                                                            
                                                            bolFile = True
                                                            
                                                        End If
                                                    
                                                    ElseIf InStr(1, arrMetaData(lngMetaItem), "StreamUrl", vbTextCompare) > 0& Then
                                                    
                                                        arrMetaInfo = Split(arrMetaData(lngMetaItem), "=")
                                                        arrMetaInfo(1) = Replace$(arrMetaInfo(1), "'", vbNullString)
                                                        
                                                        If Len(arrMetaInfo(1)) > 0& Then
                                                            strStreamUrl = arrMetaInfo(1)
                                                        End If
                                                
                                                    End If
                                                
                                                Next lngMetaItem
                                            
                                            End If
                                            
                                            If bolInfo = True Then
                                            
                                                RaiseEvent RecStreamCurrentPlaying(strStreamTitle, strStreamUrl, strMetaData)
                                                
                                            End If
                                        
                                        End If
                                    
                                        strMetaData = vbNullString
                                        
                                    End If
                                
                                Else
                                
                                    lngCount = lngCount + 1
                                
                                    If lngCount - 1 < lngMetaInt Then
                            
                                        If bolFile = True Then Put #lngFNr, , bytBuffer(lngItem)
                                
                                    Else
                        
                                        lngMetaLen = CLng(bytBuffer(lngItem)) * 16
                                        
                                        If lngMetaLen = 0& Then
                                        
                                            If bolFile = False Then
                                            
                                                lngMetaExCount = lngMetaExCount + 1
                                            
                                                If lngMetaExCount > 1 Then
                                                
                                                    lngMetaExCount = 0&
                                                
                                                    If lngFNr <> 0 Then Close #lngFNr
                                                    
                                                    lngFNr = FreeFile
                                                    
                                                    Open App.Path & "\unknown" & strFileExt For Binary As #lngFNr
                                                    
                                                    bolFile = True
                                                    
                                                    RaiseEvent RecStreamCurrentPlaying("unknown", vbNullString, vbNullString)
                                                    
                                                End If
                                                
                                            End If
                                            
                                        End If
                                        
                                        lngCount = 0

                                    End If
                            
                                End If
                    
                            Next lngItem
                            
                        End If
                    
                    End If
                    
                    DoEvents
            
                Loop Until m_StopRec = True
                
                Close #lngFNr
            
                Call InternetCloseHandle(hFile)
            
            End If
        
            Call InternetCloseHandle(hInternet)

        End If
    
    End If

End Sub

Private Sub QueryStreamUrl()

    Dim bolRet As Boolean
    Dim strRet As String
    Dim strAdr As String
    Dim strHost As String
    Dim strStream As String
    Dim lngPos As Long
    Dim lngPort As Long
    Dim lngFlag As Long
    Dim hInternet As Long
    Dim hConnect As Long
    Dim hRequest As Long

    bolRet = False

    If Len(m_strStreamUrl) > 0& Then

        If Left$(LCase$(m_strStreamUrl), Len("http://")) = "http://" Then
            strAdr = Replace$(m_strStreamUrl, "http://", vbNullString)
            lngPort = INTERNET_DEFAULT_HTTP_PORT
            lngFlag = INTERNET_FLAG_RELOAD
            
        ElseIf Left$(LCase$(m_strStreamUrl), Len("https://")) = "https://" Then
            strAdr = Replace$(m_strStreamUrl, "https://", vbNullString)
            lngPort = INTERNET_DEFAULT_HTTPS_PORT
            lngFlag = INTERNET_FLAG_RELOAD Or INTERNET_FLAG_SECURE
            
        End If
        
        If InStr(strAdr, "/") > 0& Then
            strHost = Left$(strAdr, InStr(strAdr, "/") - 1)
        ElseIf InStr(strAdr, ":") > 0& Then
            strHost = strAdr
        End If
        
        strStream = Right$(strAdr, Len(strAdr) - InStr(strAdr, "/") + 1)

        lngPos = InStr(strHost, ":")

        If lngPos > 0& Then

            lngPort = CLng(Right$(strHost, Len(strHost) - lngPos))

            strHost = Left$(strHost, lngPos - 1)

        End If

        hInternet = InternetOpen(StrPtr(WEB_AGENT), INTERNET_OPEN_TYPE_PRECONFIG _
            Or INTERNET_OPEN_TYPE_DIRECT, 0&, 0&, 0&)

        If hInternet <> 0& Then

            hConnect = InternetConnect(hInternet, StrPtr(strHost), lngPort, 0&, _
                0&, INTERNET_SERVICE_HTTP, 0&, 0&)

            If hConnect <> 0& Then

                hRequest = HttpOpenRequest(hConnect, StrPtr("GET"), StrPtr(strStream), _
                    StrPtr(WEB_VERSION), 0&, 0&, lngFlag, 0&)

                If hRequest <> 0& Then

                    If HttpSendRequest(hRequest, StrPtr(WEB_HEADER), -1&, 0&, 0&) = API_TRUE Then

                        If GetQueryInfo(hRequest, HTTP_QUERY_STATUS_CODE) = "200" Then

                            strRet = GetQueryInfo(hRequest, HTTP_QUERY_RAW_HEADERS_CRLF)
                            
                            'Debug.Print strRet
                      
                            If Len(strRet) > 0& Then

                                m_arrQueryInfo = Split(strRet, vbCrLf)

                                If UBound(m_arrQueryInfo) >= 0& Then

                                    bolRet = True

                                End If

                            End If

                        End If

                    End If

                    Call InternetCloseHandle(hRequest)

                End If

                Call InternetCloseHandle(hConnect)

            End If

            Call InternetCloseHandle(hInternet)

        End If

    End If

    RaiseEvent QueryStream(bolRet)

End Sub

Private Function GetQueryInfo(ByVal hHttpRequest As Long, _
    ByVal lInfoLevel As Long) As String

    Dim strRet As String
    Dim bytBuff() As Byte
    Dim lngBuffSize As Long

    If HttpQueryInfo(hHttpRequest, lInfoLevel, 0&, _
       VarPtr(lngBuffSize), 0&) = API_FALSE Then

        ReDim bytBuff(lngBuffSize - 1)

        If HttpQueryInfo(hHttpRequest, lInfoLevel, _
           VarPtr(bytBuff(0)), VarPtr(lngBuffSize), 0&) = API_TRUE Then

            strRet = Mid$(CStr(bytBuff), 1, lngBuffSize / 2)
            
        End If

    End If

    GetQueryInfo = strRet

End Function

