VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "WebRadio Rec-Test"
   ClientHeight    =   510
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   8610
   LinkTopic       =   "Form1"
   ScaleHeight     =   510
   ScaleWidth      =   8610
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Stop Rec"
      Height          =   405
      Left            =   1470
      TabIndex        =   1
      Top             =   60
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start Rec"
      Height          =   405
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   1335
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents cWebRadio As clsWebRadio
Attribute cWebRadio.VB_VarHelpID = -1

Private Sub Form_Load()

    Dim lngItem As Long
    Dim lngCount As Long
    Dim strStreamUrl As String
    Dim strStreamTitle As String
    Dim strStreamAdr As String
    
    Command1.Enabled = False
    Command2.Enabled = False
    
    Me.Show
    DoEvents
    
    ' Streams!
    'strStreamAdr = "http://www.schwarze-welle.de:7500"
    'strStreamAdr = "http://tunein.t4e.dj/hard/dsl/mp3"
    'strStreamAdr = "http://server4.streamserver24.com:26583/stream"
    strStreamAdr = "http://rb-bremenvier-live.cast.addradio.de/rb/bremenvier/live/mp3/128/stream.mp3"
    
    ' HiRes Streams!
    'strStreamAdr = "https://secure.live-streams.nl/flac.flac"
    'strStreamAdr = "https://intenseradio.live-streams.nl:18000/low"
    
    ' Playlist!
    'strStreamAdr = "http://www.ndr.de/resources/metadaten/audio/m3u/n-joy.m3u"
    
    Set cWebRadio = New clsWebRadio
    
    
    If cWebRadio.IsUrlPlaylist(strStreamAdr) = True Then
    
        'Debug.Print cWebRadio.GetPlaylistInfoRawCrLf
        
        lngCount = cWebRadio.GetPlaylistNumberOfEntries
        
        If lngCount > 0& Then
            
            For lngItem = 0 To lngCount - 1
            
                Call cWebRadio.GetPlaylistEntry(lngItem, strStreamUrl, strStreamTitle)
            
                Debug.Print "StreamUrl = " & strStreamUrl
                Debug.Print "StreamTitle = " & strStreamTitle
            
            Next lngItem
            
            Call cWebRadio.GetPlaylistEntry(0&, strStreamUrl, strStreamTitle)
            
            cWebRadio.StreamUrl = strStreamUrl
        
        End If
        
    Else
    
        cWebRadio.StreamUrl = strStreamAdr
    
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    Call cWebRadio.StopRecStream
    
    DoEvents

    Set cWebRadio = Nothing

End Sub

Private Sub Command1_Click()

    Command1.Enabled = False
    Command2.Enabled = True

    If Len(cWebRadio.GetStreamQueryInfo(IcyMetaInt)) > 0& Then

    Call cWebRadio.StartRecStream(cWebRadio.GetStreamQueryInfo(ContentType), _
        cWebRadio.GetStreamQueryInfo(IcyMetaInt))
        
    Else
    
        Call cWebRadio.StartRecStream(cWebRadio.GetStreamQueryInfo(ContentType))
    
    End If

End Sub

Private Sub Command2_Click()

    Call cWebRadio.StopRecStream
    
    DoEvents
    Me.Caption = "Rec stopped"
    
    Command1.Enabled = True
    Command2.Enabled = False

End Sub

Private Sub cWebRadio_QueryStream(ByVal bQueryOk As Boolean)
    
    Dim strIcyAudioInfo As String
    
    If bQueryOk = True Then
    
        Command1.Enabled = True
        Command2.Enabled = False
    
        'Debug.Print cWebRadio.GetStreamQueryInfoRawCrLf

        Debug.Print "IcyMetaInt = " & cWebRadio.GetStreamQueryInfo(IcyMetaInt)
        Debug.Print "IcyName = " & cWebRadio.GetStreamQueryInfo(IcyName)
        Debug.Print "ContentType = " & cWebRadio.GetStreamQueryInfo(ContentType)
        
        strIcyAudioInfo = cWebRadio.GetStreamQueryInfo(IceAudioInfo)
        
        If Len(strIcyAudioInfo) > 0& Then
            Debug.Print "Info = " & strIcyAudioInfo
        Else
            Debug.Print cWebRadio.GetStreamQueryInfo(IcyAudioInfo)
        End If

    End If

End Sub

Private Sub cWebRadio_RecStreamCurrentPlaying(ByVal sStreamTitle As String, _
                                              ByVal sStreamUrl As String, _
                                              ByVal sStreamMetaDataRaw As String)

    Me.Caption = "Rec started -> Now Playing: " & sStreamTitle

End Sub

